package productrpc

import (
	"encoding/json"
	// "strconv"
	// "time"
)

/**
 * 获取商品进行中活动
 * 2021/10/06
 * GZ
 */
func GetActivity(site_id, dbname, id string, sku_id string, url ...string) ([]map[string]string, error) {

	conn, err := rpc_server_conn(url...)
	if err != nil {
		return nil, err
	}
	defer conn.Close()

	arg := GetActivityParam{site_id, dbname, id, sku_id}

	req, err := SetReqData(arg)
	if err != nil {
		return nil, err
	}

	res := &Response{}

	err = conn.GetActivity(req, res)

	if err != nil {
		return nil, err
	}

	res_data_de, err := GetResData(res)
	if err != nil {
		return nil, err
	}
	if res_data_de == "" {
		return nil, nil
	}
	var res_arr []map[string]string

	err = json.Unmarshal([]byte(res_data_de), &res_arr)

	if err != nil {
		return nil, err
	}
	return res_arr, nil
}

/**
 * 获取商品预热中活动
 * 2021/10/06
 * GZ
 */
func GetWarmingActivity(site_id, dbname, id string, sku_id string, url ...string) ([]map[string]string, error) {

	conn, err := rpc_server_conn(url...)
	if err != nil {
		return nil, err
	}
	defer conn.Close()

	arg := GetActivityParam{site_id, dbname, id, sku_id}

	req, err := SetReqData(arg)
	if err != nil {
		return nil, err
	}

	res := &Response{}

	err = conn.GetWarmingActivity(req, res)

	if err != nil {
		return nil, err
	}

	res_data_de, err := GetResData(res)
	if err != nil {
		return nil, err
	}
	if res_data_de == "" {
		return nil, nil
	}
	var res_arr []map[string]string

	err = json.Unmarshal([]byte(res_data_de), &res_arr)

	if err != nil {
		return nil, err
	}
	return res_arr, nil
}

/**
 * 获取商品进行中活动
 * 2021/10/06
 * GZ
 */
func GetAllActivity(site_id, dbname, id string, sku_id string, url ...string) ([]map[string]string, error) {

	conn, err := rpc_server_conn(url...)
	if err != nil {
		return nil, err
	}
	defer conn.Close()

	arg := GetActivityParam{site_id, dbname, id, sku_id}

	req, err := SetReqData(arg)
	if err != nil {
		return nil, err
	}

	res := &Response{}

	err = conn.GetAllActivity(req, res)

	if err != nil {
		return nil, err
	}

	res_data_de, err := GetResData(res)
	if err != nil {
		return nil, err
	}
	if res_data_de == "" {
		return nil, nil
	}
	var res_arr []map[string]string

	err = json.Unmarshal([]byte(res_data_de), &res_arr)

	if err != nil {
		return nil, err
	}
	return res_arr, nil
}
